/*
 * PROJECT:     F-Test
 * LICENSE:     EUPL - https://joinup.ec.europa.eu/software/page/eupl
 * PURPOSE:     RC Supplement Library functionality test
 * PROGRAMMERS: Ștefan Fulea (stefan.fulea@mail.md)
 */

#include <WinDef.h>
#include <WinBase.h>
#include <WinCon.h>
#include <WinUser.h>
#include <stdlib.h>

#include "f-test.h"
#include "rcsuplib.h"

#include <conio.h>

INT wmain (INT argc, PWCHAR argvW[])
{
    WORD wDecidingValue;
    PWCHAR pwsLoadedStr;
    PCHAR psResPtr;
    PWCHAR pwsResPtr;
    WORD wResValue;
    DWORD dwResValue;

    switch(argc)
    {
        case 2:
            wDecidingValue = _wtoi(argvW[1]);

            /* (normal) string test */
            LoadStringW(NULL, STRINGLABEL_WSTR_ID, (PWCHAR) &pwsLoadedStr, 0);
            _cwprintf(pwsLoadedStr);
            RCS_LoadStringA(NULL, PLURALFORMS_STRSET_ID,
                            (PCHAR) &psResPtr, 0,
                            wDecidingValue);

            _cprintf(psResPtr, wDecidingValue);

            /* wide string test */
            LoadStringW(NULL, WSTRINGLABEL_WSTR_ID, (PWCHAR) &pwsLoadedStr, 0);
            _cwprintf(pwsLoadedStr);
            RCS_LoadStringW(NULL, PLURALFORMS_WSTRSET_ID,
                            (PWCHAR) &pwsResPtr, 0,
                            wDecidingValue);
            _cwprintf(pwsResPtr, wDecidingValue);

            /* WORD-number test */
            LoadStringW(NULL, WORDLABEL_WSTR_ID, (PWCHAR) &pwsLoadedStr, 0);
            _cwprintf(pwsLoadedStr);
            RCS_LoadWORD(NULL, PLURALFORMS_WORDSET_ID,
                         &wResValue, wDecidingValue);
            _cprintf("%d", wResValue);

            /* DWORD-number test */
            LoadStringW(NULL, DWORDLABEL_WSTR_ID, (PWCHAR) &pwsLoadedStr, 0);
            _cwprintf(pwsLoadedStr);
            RCS_LoadDWORD(NULL, PLURALFORMS_DWORDSET_ID,
                          &dwResValue, wDecidingValue);
            _cprintf("%d", dwResValue);
            break;

        default:
            LoadStringW(NULL, HELP_WSTR_ID, (PWCHAR) &pwsLoadedStr, 0);
            _cwprintf(pwsLoadedStr);
    };

    return 0;
}

/* EOF */
